#include "stm32f30x.h"
#include "delay.h"

/****************************************************************************************************/

static volatile uint8_t wait;

/****************************************************************************************************/

void SysTick_Handler(void) {
	SysTick->CTRL = 0;	// disable SysTick timer
	wait = 0;			// release delay function
}

/****************************************************************************************************/

void delay_us(uint32_t time) {
	// maximum delay ~1.86sec
	wait = 1;

	// initialize SysTick timer
	SysTick->LOAD = (9 * time) - 1;
	SysTick->VAL = 0;
	SysTick->CTRL = SysTick_CTRL_TICKINT_Msk | SysTick_CTRL_ENABLE_Msk;

	while (wait);
}

/****************************************************************************************************/
